Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.26
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.macs
Class CFBBlockCipherMac

    java.lang.Object
      |
      +--org.bouncycastle.crypto.macs.CFBBlockCipherMac

All Implemented Interfaces:
  Mac

public class CFBBlockCipherMac
extends java.lang.Object
implements Mac

Constructor Summary
`CFBBlockCipherMac(BlockCipher cipher)` create a standard MAC based on a CFB block cipher.
`CFBBlockCipherMac(BlockCipher cipher, BlockCipherPadding padding)` create a standard MAC based on a CFB block cipher.
`CFBBlockCipherMac(BlockCipher cipher, int cfbBitSize, int macSizeInBits)` create a standard MAC based on a block cipher with the size of the MAC been given in bits.
`CFBBlockCipherMac(BlockCipher cipher, int cfbBitSize, int macSizeInBits, BlockCipherPadding padding)` create a standard MAC based on a block cipher with the size of the MAC been given in bits.

Method Summary
`int` | `doFinal(byte[] out, int outOff)` Compute the final statge of the MAC writing the output to the out parameter.
`java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
`int` | `getMacSize()` Return the block size for this cipher (in bytes).
`void` | `init(CipherParameters params)` Initialise the MAC.
`void` | `reset()` Reset the mac generator.
`void` | `update(byte in)` add a single byte to the mac for processing.
`void` | `update(byte[] in, int inOff, int len)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CFBBlockCipherMac

    public CFBBlockCipherMac(BlockCipher cipher)

  create a standard MAC based on a CFB block cipher. This will produce an authentication code half the length of the block size of the cipher, with the CFB mode set to 8 bits.
  Parameters:
    `cipher` - the cipher to be used as the basis of the MAC generation.

### CFBBlockCipherMac

    public CFBBlockCipherMac(BlockCipher cipher,
                             BlockCipherPadding padding)

  create a standard MAC based on a CFB block cipher. This will produce an authentication code half the length of the block size of the cipher, with the CFB mode set to 8 bits.
  Parameters:
    `cipher` - the cipher to be used as the basis of the MAC generation.
    `padding` - the padding to be used.

### CFBBlockCipherMac

    public CFBBlockCipherMac(BlockCipher cipher,
                             int cfbBitSize,
                             int macSizeInBits)

  create a standard MAC based on a block cipher with the size of the MAC been given in bits. This class uses CFB mode as the basis for the MAC generation.

  Note: the size of the MAC must be at least 24 bits (FIPS Publication 81), or 16 bits if being used as a data authenticator (FIPS Publication 113), and in general should be less than the size of the block cipher as it reduces the chance of an exhaustive attack (see Handbook of Applied Cryptography).

  Parameters:
    `cipher` - the cipher to be used as the basis of the MAC generation.
    `cfbBitSize` - the size of an output block produced by the CFB mode.
    `macSizeInBits` - the size of the MAC in bits, must be a multiple of 8.

### CFBBlockCipherMac

    public CFBBlockCipherMac(BlockCipher cipher,
                             int cfbBitSize,
                             int macSizeInBits,
                             BlockCipherPadding padding)

  create a standard MAC based on a block cipher with the size of the MAC been given in bits. This class uses CFB mode as the basis for the MAC generation.

  Note: the size of the MAC must be at least 24 bits (FIPS Publication 81), or 16 bits if being used as a data authenticator (FIPS Publication 113), and in general should be less than the size of the block cipher as it reduces the chance of an exhaustive attack (see Handbook of Applied Cryptography).

  Parameters:
    `cipher` - the cipher to be used as the basis of the MAC generation.
    `cfbBitSize` - the size of an output block produced by the CFB mode.
    `macSizeInBits` - the size of the MAC in bits, must be a multiple of 8.
    `padding` - a padding to be used.

Method Detail

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Description copied from interface: `Mac`
  Return the name of the algorithm the MAC implements.
  Specified by:
    `getAlgorithmName` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Returns:
    the name of the algorithm the MAC implements.

### init

    public void init(CipherParameters params)

  Description copied from interface: `Mac`
  Initialise the MAC.
  Specified by:
    `init` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Parameters:
    `params` - the key and other data required by the MAC.
  Throws:
    `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

### getMacSize

    public int getMacSize()

  Description copied from interface: `Mac`
  Return the block size for this cipher (in bytes).
  Specified by:
    `getMacSize` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Returns:
    the block size for this cipher in bytes.

### update

    public void update(byte in)

  Description copied from interface: `Mac`
  add a single byte to the mac for processing.
  Specified by:
    `update` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Parameters:
    `in` - the byte to be processed.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### update

    public void update(byte[] in,
                       int inOff,
                       int len)

  Specified by:
    `update` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Parameters:
    `in` - the array containing the input.
    `inOff` - the index in the array the data begins at.
    `len` - the length of the input starting at inOff.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.
    `DataLengthException` - if there isn't enough data in in.

### doFinal

    public int doFinal(byte[] out,
                       int outOff)

  Description copied from interface: `Mac`
  Compute the final statge of the MAC writing the output to the out parameter.

  doFinal leaves the MAC in the same state it was after the last init.

  Specified by:
    `doFinal` in interface `Mac`
  Following copied from interface: `org.bouncycastle.crypto.Mac`
  Parameters:
    `out` - the array the MAC is to be output to.
    `outOff` - the offset into the out buffer the output is to start at.
  Throws:
    `DataLengthException` - if there isn't enough space in out.
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### reset

    public void reset()

  Reset the mac generator.
  Specified by:
    `reset` in interface `Mac`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.26
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD